package ssw.mj;

import java.io.IOException;
import java.io.Reader;
import java.util.HashMap;
import java.util.Map;

import ssw.mj.Errors.Message;

import static ssw.mj.Token.Kind.*;
import static ssw.mj.Errors.Message.*;

/**
 * The Scanner for the MicroJava Compiler.
 */
public class Scanner {
	private static final char EOF = (char) -1;
	private static final char CR = '\r';
	private static final char LF = '\n';

	/** Input data to read from. */
	private Reader in;

	/** Lookahead character. (= next (unhandled) character in the input stream) */
	private char ch;

	/** Current line in input stream. */
	private int line;

	/** Current column in input stream. */
	private int col;

	/** According errors object. */
	public Errors errors;

	// TODO Exercise 2: implementation of scanner

	public Scanner(Reader r) {
		// initialize error handling support
		errors = new Errors();
	}

	/**
	 * Adds error message to the list of errors.
	 */
	private void error(Token t, Message msg, Object... msgParams) {
		errors.error(t.line, t.col, msg, msgParams);

		// reset token content (consistent JUnit tests)
		t.val = 0;
		t.str = null;
	}

	/**
	 * Returns next token. To be used by parser.
	 */
	public Token next() {
		return new Token(Token.Kind.eof, 1, 1);
	}
}
