package ssw.mj.symtab;

import static ssw.mj.Errors.Message.DECL_NAME;
import static ssw.mj.Errors.Message.NOT_FOUND;
import static ssw.mj.Errors.Message.NO_FIELD;
import ssw.mj.Parser;

/**
 * MicroJava Symbol Table
 */
public class Tab {
	// Universe
	public static final Struct noType = new Struct(Struct.Kind.None);
	public static final Struct intType = new Struct(Struct.Kind.Int);
	public static final Struct charType = new Struct(Struct.Kind.Char);
	public static final Struct nullType = new Struct(Struct.Kind.Class);

	public Obj noObj, chrObj, ordObj, lenObj;

	/** Only used for reporting errors. */
	public Parser parser;
	/** The current top scope. */
	public Scope topScope;
	/** Nesting level of current scope. */
	private int level;

	// TODO Exercise 4: implementation of symbol table

	/**
	 * Set up "universe" (= predefined names).
	 */
	public Tab(Parser p) {
		parser = p;
	}

	/**
	 * String representation for JUnit test cases.
	 */
	public String dump() {
		StringBuilder sb = new StringBuilder();
		if (topScope != null) {
			topScope.dump(sb);
		}
		return sb.toString();
	}
}
